/******************************************************************************
*
* project name:    TI-Chess
* file name:       gray_ti89.h
* initial date:    07/08/2000
* authors:         thomas.nussbaumer@gmx.net (coding)
*                  marcos.lopez@wol.es (design/graphics/beta testing)
* description:     better grayscales for TI89 HW2 (less or no flickers by
*                  just copying 2000 bytes instead of 3840 bytes)
*
* original version taken from TIGCC Libary 2.0 (c) Zeljko Juric
*
* $Id: gray_ti89.h,v 1.2 2000/08/12 15:31:12 Thomas Nussbaumer Exp $
*
******************************************************************************/

#ifndef __GRAY_TI89_H__
#define __GRAY_TI89_H__

asm("xdef __gm
     xdef __gp0
     xdef __gp1
__gm:    tst.w 4(%sp)
         beq __goff
         move.l 0xC8,%d1
         and.l #0x600000,%d1
         move.l %d1,%a1
         move.l (%a1,260),%a0
         move.l %a0,%d0
         sub.l %d1,%d0
         move.l #3858,-(%sp)
         moveq #1,%d1
         cmp.l #0xFFFF,%d0
         bhi.s __gnhw2
         cmpi.w #0x16,(%a0)
         bls.s __gnhw2
         move.l (%a0,0x16),%d1
         cmp.w #2,%d1
         bne __gnhw2
         move.l #7690,(%sp)
__gnhw2: move.w %d1,__ghwmd
         movea.l 0xC8,%a0
         movea.l (%a0,0xA2*4),%a0
         jsr (%a0)                  /* HeapAllocPtr */
         addq.l #4,%sp
         move.l %a0,%d0
         beq __gfail
         move.l %a0,__gptr
         add.l #3840,%a0
         move.l #0x30003,%d1
         cmp.w #2,__ghwmd
         beq __gcont
         add.l #7,%d0
         lsr.l #3,%d0
         move.w %d0,__gtab
         lsl.l #3,%d0
         move.l #0x4C00,%a0
         move.l #0x40004,%d1
__gcont: move.l %d0,__gp0
         move.l %a0,__gp1
         move.l %d1,__gcnt
         move.l #0xEF007F,-(%sp)
         move.l %a0,-(%sp)
         movea.l 0xC8,%a0
         movea.l (%a0,0x1A2*4),%a0
         jsr (%a0)                  /* PortSet */
         addq.l #8,%sp
         move.w #0x0700,%d0
         trap #1
         move.l 0x64,__oldi1
         move.l #__int1,0x40064
__gdone: trap #1
         moveq #1,%d0
         rts
__gfail: clr.l   %d0
         rts
__goff:  movea.l __gptr(%pc),%a0
         move.l %a0,%d0
         beq __gfail
         clr.l __gptr
         move.l #0x4C004C00,__gp0
         move.l %a0,-(%sp)
         movea.l 0xC8,%a0
         movea.l (%a0,0xA3*4),%a0
         jsr (%a0)                  /* HeapFreePtr */
         addq.l #4,%sp
         movea.l 0xC8,%a0
         movea.l (%a0,0x1A3*4),%a0
         jsr (%a0)                  /* PortRestore */
         move.w #0x980,0x600010
         move.w #0x0700,%d0
         trap #1
         move.l __oldi1(%pc),0x40064
         clr.w %d0
         bra.s __gdone
__int1:  move.w #0x2700,%sr
         subq.w  #1,__gcnt
         bne __i1skp
         movem.l %d0-%d7/%a0-%a6,-(%sp)
         move.w __gmax(%pc),%d0
         move.w %d0,__gcnt
         move.w __gphs(%pc),%d0
         addq.w #2,%d0
         cmp.w #6,%d0
         bne __i1nwp
         clr.w %d0
__i1nwp: move.w %d0,__gphs
         cmp.w #4,%d0
         beq __i1done
         cmp.w #2,__ghwmd
         bne __i1hw1
         lea __gp0(%pc),%a0
         add.w %d0,%d0
         move.l (%a0,%d0.w),%a0

         /* copy routine                               */
         /* old variant -- copies 3840 bytes each time */
         /*
         move.l #0x4C00,%a1
         moveq #79,%d0
_i1hw2lp:movem.l (%a0)+,%d1-%d7/%a2-%a6
         movem.l %d1-%d7/%a2-%a6,(%a1)
         lea (%a1,48),%a1
         dbra %d0,_i1hw2lp
         */

         /* new variant -- copies only 2000 bytes */

         move.l #0x4C00,%a1
         moveq #100,%d0                 /* TI-89 has 100 lines */
_i1hw2lp:movem.l (%a0),%d1-%d5          /* copy 4*5 = 20 bytes */
         movem.l %d1-%d5,(%a1)
         add.w #30,%a0
         add.w #30,%a1
         dbra %d0,_i1hw2lp

         bra.s __i1done
__i1hw1: lea __gtab(%pc),%a0
         move.w (%a0,%d0.w),0x600010
__i1done:movem.l (%sp)+,%d0-%d7/%a0-%a6
__i1skp: move.l __oldi1(%pc),-(%sp)
         rts
__ghwmd: dc.w 0
__gp0:   dc.l 0x4C00
__gp1:   dc.l 0x4C00
__oldi1: dc.l 0
__gptr:  dc.l 0
__gcnt:  dc.w 3
__gmax:  dc.w 3
__gphs:  dc.w 0
__gtab:  dc.w 0
         dc.w 0x980");

#endif



//#############################################################################
//###################### NO MORE FAKES BEYOND THIS LINE #######################
//#############################################################################
//
//=============================================================================
// Revision History
//=============================================================================
//
// $Log: gray_ti89.h,v $
// Revision 1.2  2000/08/12 15:31:12  Thomas Nussbaumer
// substitution keywords added
//
//
