/******************************************************************************
*
* project name:    TI-Chess
* file name:       input.h
* initial date:    13/07/2000
* authors:         thomas.nussbaumer@gmx.net (coding)
*                  marcos.lopez@wol.es (design/graphics/beta testing)
* description:     key definitions
*
* $Id: input.h,v 1.2 2000/08/12 15:31:13 Thomas Nussbaumer Exp $
*
******************************************************************************/

#ifndef __INPUT_H__
#define __INPUT_H__

//=============================================================================
// NOTE: due to our own keyhandler the following keycodes are NOT equal to the
//       real ones, but this way the TI89 and the TI92 can be treated
//       equally !!!
//=============================================================================

//-----------------------------------------------------------------------------
// cursor keys
//-----------------------------------------------------------------------------
#define KEY_MLEFT        337
#define KEY_MRIGHT       340
#define KEY_MUP          338
#define KEY_MDOWN        344



//-----------------------------------------------------------------------------
// other keys
//-----------------------------------------------------------------------------
#define KEY_ESCAPE       264
#define KEY_ENTER         13
#define KEY_OFF         4363
#define KEY_BACK         257
#define KEY_LOADSAVE     258
#define KEY_LEVELUP      ')'
#define KEY_LEVELDOWN    '('
#define KEY_EXIT         'x'
#define KEY_SHOWMOVES    's'
#define KEY_CHANGESIDE   'c'
#define KEY_TWOPLAYER    '2'
#define KEY_ROTATE       'r'
#define KEY_HELP         'h'
#define KEY_FORWARD      'f'
#define KEY_AUTOMATIC    'a'
#define KEY_MLEFT        337
#define KEY_MRIGHT       340
#define KEY_MUP          338
#define KEY_MDOWN        344
#define KEY_CONTRASTUP   900
#define KEY_CONTRASTDN   901

#if ENABLE_TESTKEY
#define KEY_TESTING '='
#endif

#endif


//#############################################################################
//###################### NO MORE FAKES BEYOND THIS LINE #######################
//#############################################################################
//
//=============================================================================
// Revision History
//=============================================================================
//
// $Log: input.h,v $
// Revision 1.2  2000/08/12 15:31:13  Thomas Nussbaumer
// substitution keywords added
//
//
